# coding: utf-8

"""
    torc

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: v0.6.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from torc.openapi_client.models.compute_node_schedule_params import ComputeNodeScheduleParams
from typing import Optional, Set
from typing_extensions import Self

class JobSpecificationModel(BaseModel):
    """
    JobSpecificationModel
    """ # noqa: E501
    name: Optional[StrictStr] = Field(default=None, description="Name of the job; must be unique within the workflow specification.")
    key: Optional[StrictStr] = Field(default=None, description="Optional database identifier for the job. If set, must be unique. It is recommended to let the database create the identifier.")
    command: StrictStr = Field(description="CLI command to execute. Will not be executed in a shell and so must not include shell characters.")
    invocation_script: Optional[StrictStr] = Field(default=None, description="Wrapper script for command in case the environment needs customization.")
    cancel_on_blocking_job_failure: Optional[StrictBool] = Field(default=True, description="Cancel this job if any of its blocking jobs fails.")
    supports_termination: Optional[StrictBool] = Field(default=False, description="Informs torc that the job can be terminated gracefully before a wall-time timeout.")
    scheduler: Optional[StrictStr] = Field(default=None, description="Optional name of scheduler needed by this job")
    schedule_compute_nodes: Optional[ComputeNodeScheduleParams] = None
    input_user_data: Optional[List[StrictStr]] = Field(default=None, description="Names of user-data objects that this job needs")
    output_user_data: Optional[List[StrictStr]] = Field(default=None, description="Names of user-data objects that this job produces")
    resource_requirements: Optional[StrictStr] = Field(default=None, description="Optional name of resources required by this job")
    input_files: Optional[List[StrictStr]] = Field(default=None, description="Names of files that this job needs")
    output_files: Optional[List[StrictStr]] = Field(default=None, description="Names of files that this job produces")
    blocked_by: Optional[List[StrictStr]] = Field(default=None, description="Names of jobs that block this job")
    __properties: ClassVar[List[str]] = ["name", "key", "command", "invocation_script", "cancel_on_blocking_job_failure", "supports_termination", "scheduler", "schedule_compute_nodes", "input_user_data", "output_user_data", "resource_requirements", "input_files", "output_files", "blocked_by"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of JobSpecificationModel from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of schedule_compute_nodes
        if self.schedule_compute_nodes:
            _dict['schedule_compute_nodes'] = self.schedule_compute_nodes.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of JobSpecificationModel from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "key": obj.get("key"),
            "command": obj.get("command"),
            "invocation_script": obj.get("invocation_script"),
            "cancel_on_blocking_job_failure": obj.get("cancel_on_blocking_job_failure") if obj.get("cancel_on_blocking_job_failure") is not None else True,
            "supports_termination": obj.get("supports_termination") if obj.get("supports_termination") is not None else False,
            "scheduler": obj.get("scheduler"),
            "schedule_compute_nodes": ComputeNodeScheduleParams.from_dict(obj["schedule_compute_nodes"]) if obj.get("schedule_compute_nodes") is not None else None,
            "input_user_data": obj.get("input_user_data"),
            "output_user_data": obj.get("output_user_data"),
            "resource_requirements": obj.get("resource_requirements"),
            "input_files": obj.get("input_files"),
            "output_files": obj.get("output_files"),
            "blocked_by": obj.get("blocked_by")
        })
        return _obj
